<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TransportRoutePortfolioRQ StructType
 * @subpackage Structs
 */
class JP_TransportRoutePortfolioRQ extends AbstractStructBase
{
    /**
     * The Login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Login
     */
    public $Login;
    /**
     * The ModuleTypes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString12
     */
    public $ModuleTypes;
    /**
     * The Version
     * @var string
     */
    public $Version;
    /**
     * The Language
     * @var string
     */
    public $Language;
    /**
     * Constructor method for JP_TransportRoutePortfolioRQ
     * @uses JP_TransportRoutePortfolioRQ::setLogin()
     * @uses JP_TransportRoutePortfolioRQ::setModuleTypes()
     * @uses JP_TransportRoutePortfolioRQ::setVersion()
     * @uses JP_TransportRoutePortfolioRQ::setLanguage()
     * @param \StructType\JP_Login $login
     * @param \ArrayType\ArrayOfString12 $moduleTypes
     * @param string $version
     * @param string $language
     */
    public function __construct(\StructType\JP_Login $login = null, \ArrayType\ArrayOfString12 $moduleTypes = null, $version = null, $language = null)
    {
        $this
            ->setLogin($login)
            ->setModuleTypes($moduleTypes)
            ->setVersion($version)
            ->setLanguage($language);
    }
    /**
     * Get Login value
     * @return \StructType\JP_Login|null
     */
    public function getLogin()
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param \StructType\JP_Login $login
     * @return \StructType\JP_TransportRoutePortfolioRQ
     */
    public function setLogin(\StructType\JP_Login $login = null)
    {
        $this->Login = $login;
        return $this;
    }
    /**
     * Get ModuleTypes value
     * @return \ArrayType\ArrayOfString12|null
     */
    public function getModuleTypes()
    {
        return $this->ModuleTypes;
    }
    /**
     * Set ModuleTypes value
     * @param \ArrayType\ArrayOfString12 $moduleTypes
     * @return \StructType\JP_TransportRoutePortfolioRQ
     */
    public function setModuleTypes(\ArrayType\ArrayOfString12 $moduleTypes = null)
    {
        $this->ModuleTypes = $moduleTypes;
        return $this;
    }
    /**
     * Get Version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \StructType\JP_TransportRoutePortfolioRQ
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->Version = $version;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\JP_TransportRoutePortfolioRQ
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
}
